<template>
  <ElIcon class="toggle-dark-mode-btn" @click="toggleDarkMode">
    <Sunny v-if="!darkMode" />
    <Moon v-else />
  </ElIcon>
</template>

<script lang="ts" setup>
import { Sunny, Moon } from "@element-plus/icons-vue";

const darkMode = useDark();
const isDarkModePreferred = usePreferredDark();

const toggleDarkMode = () => {
  if (window.localStorage) {
    window.localStorage.setItem(
      "video-transcoder-dark-mode",
      `${!darkMode.value}`
    );
  }
  darkMode.value = !darkMode.value;
};

if (window.localStorage) {
  darkMode.value =
    (window.localStorage.getItem("video-transcoder-dark-mode") ??
      `${isDarkModePreferred.value}`) === "true";
}
</script>

<style lang="scss" scoped>
.toggle-dark-mode-btn {
  cursor: pointer;
  user-select: none;
  -moz-user-select: none;
  -webkit-user-select: none;
}
</style>
